//Gia na mhn emfanizetai to console Window sthn arxh tou programmatos prepei na topoqeteitai to: 
#pragma comment( linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"" )

#include <stdio.h>
#include <glut.h>

#define LINE 1
#define RECTANGLE 2
#define LINE_RED_COLOR 3
#define LINE_GREEN_COLOR 4
#define LINE_BLUE_COLOR 5
#define CLEAR_SCREEN 6

GLint screenWidth= 640;
GLint screenHeight =480;

int menu; // for menu creation
int selection; // for menu choices
int sxhma; // for drawing line or rectangle

 typedef struct 
 { 
	 GLint x,y;
 }
 GLintPoint;


void drawPoint( int ax, int ay)
{
	glBegin(GL_POINTS);
		glVertex2i(ax,ay);
	glEnd();
	glFlush();
}

void drawLine(int ax, int ay, int bx, int by)
{
	glBegin(GL_LINES);
		glVertex2i(ax,ay);
		glVertex2i(bx, by);
	glEnd();
	glFlush();
}

void myInit (void)
{
	glClear(GL_COLOR_BUFFER_BIT);		// clear the screen
	glClearColor(0.0, 0.0, 0.0, 0.0);    // select clearing (background) color
	//glColor3f(1.0, 1.0, 1.0);           // initialize viewing color values
	glColor3f(0.0,0.0,1.0);
	glPointSize(4);						// set point size
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluOrtho2D(0.0,(GLfloat)screenWidth, 0.0,(GLfloat)screenHeight);// Creates a matrix for projecting two dimensional
																	// coordinates onto the screen and multiplies the 
																	// current projection matrix by it.
																	// It is used for projecting a two dimensional image 
																	// onto a two dimensional screen. 
																	// For two dimensional objects using two dimensional 
																	// vertex commands all z coordinates are zero.
	glFlush();
}
										

void myDisplay(void)
{
	glClear(GL_COLOR_BUFFER_BIT);		// clear the screen

	glFlush();							// send all output to display
}

 //Specifying a rectangle with the mouse
void myMouse (int button, int state, int x1, int y1)
{
	static GLintPoint corner[2];
	static int numCorners = 0;
	if (button == GLUT_LEFT_BUTTON && state ==GLUT_DOWN)
	{		
		corner[numCorners].x =x1;
		corner[numCorners].y = screenHeight-y1;
		drawPoint(corner[numCorners].x,corner[numCorners].y);
		numCorners++;
		if (numCorners == 2)
		{
			//glColor3f(0.0,0.0,1.0);
		
			if(sxhma == 2)
			{
				
				//glColor3f(1.0,0.0,0.0);
				
				glRecti(corner[0].x, corner[0].y, corner[1].x, corner[1].y);
			}
			if (sxhma == 1)
			{
				//glColor3f(0.0,1.0, 0.0);
				drawLine(corner[0].x, corner[0].y, corner[1].x, corner[1].y);
			}
			numCorners =0;
		}
	}
		else if (button == GLUT_MIDDLE_BUTTON && state == GLUT_DOWN)
			glClear(GL_COLOR_BUFFER_BIT);  // clear the window
		
		glFlush();
	
}
	// triggered when a Keyboard key is pressed
void keyEvent(unsigned char key, int x, int y)
{
	switch (key)
	{
		//Quit
		case 'Q':
		case 'q':
		exit(-1);
		break;
		default:
		break;
	}
}

// Menu choices
void myMenu(int selection)
{
	switch(selection) {

		case LINE: // drawing  line
			sxhma=1;
			glutPostRedisplay(); // put comments to see what happens
			break;

		case RECTANGLE: // drawing rectangle
			sxhma=2;
			glutPostRedisplay();
			break;

		case LINE_RED_COLOR:
			glColor3f(1.0,0.0,0.0);
			break;

		case LINE_GREEN_COLOR:
			glColor3f(0.0,1.0,0.0);
			break;

		case LINE_BLUE_COLOR:
			glColor3f(0.0,0.0,1.0);
			break;

		case CLEAR_SCREEN:
			glClear(GL_COLOR_BUFFER_BIT);  // clear the window
			glFlush();
			break;

		default:
			printf("Invalid menu selection\n");
			break;
	}

}



int main(int argc, char **argv)
{

	int menu, lineColorSubmenu;
	
	// initialize toolkit
	glutInit(&argc, argv);
	// set display mode
	glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
	// set window size
	glutInitWindowSize (screenWidth, screenHeight);
	// set window initial position
	glutInitWindowPosition(1,1);
	// creates a window
	glutCreateWindow ("Pop-up menu");
	// registers a redraw function, this function is called whenever 
	// the system determines that the window should be redrawn.
	// This first happens when the window is first opened.
	glutDisplayFunc(myDisplay);
	// registers a keyboard handler
	glutKeyboardFunc(keyEvent);
	glutMouseFunc(myMouse);
	
	// Create a two-level pop-up menu
	lineColorSubmenu = glutCreateMenu(myMenu);
	glutAddMenuEntry("Red", LINE_RED_COLOR);
	glutAddMenuEntry("Green", LINE_GREEN_COLOR);
	glutAddMenuEntry("Blue", LINE_BLUE_COLOR);

	
	// menu creation
	menu = glutCreateMenu(myMenu);
	glutAddMenuEntry("Line", LINE);
	glutAddMenuEntry("Rectangle", RECTANGLE);
	glutAddSubMenu("Line Color", lineColorSubmenu);
	glutAddMenuEntry("Clear Screen", CLEAR_SCREEN);

	// register menu to right mouse button
	glutAttachMenu(GLUT_RIGHT_BUTTON);

	//Initializations
	myInit();

	// perpetual ever processing loop
	glutMainLoop();

	glutDestroyMenu(lineColorSubmenu);
	glutDestroyMenu(menu);

	return 0;
}

