#include <glut.h>

int screenWidth = 640;
int screenHeight = 480;

class GLintPoint{
public:
	GLint x,y;
};

GLint numCorners=0;

void drawPoint(GLint x, GLint y);
GLintPoint clipWindow[2];
void init (void)
{
	glClear(GL_COLOR_BUFFER_BIT);//The buffers currently enabled for color writing 
	glClearColor (0.0, 0.0, 0.0, 0.0);	// select clearing (background) color
   	glColor3f(1.0, 1.0, 1.0); 			
			
	glMatrixMode(GL_PROJECTION);		
	glLoadIdentity(); 
	gluOrtho2D(0.0,(GLdouble)screenWidth,0.0,(GLdouble)screenHeight);	//define a 2-D orthographic projection matrix 
}


void display(void){
	
	glClear(GL_COLOR_BUFFER_BIT);	//The buffers currently enabled for color writing
	glColor3f(1.0, 0.0, 0.0); 

	if (numCorners ==2)
		glRecti(clipWindow[0].x, clipWindow[0].y, clipWindow[1].x, clipWindow[1].y);

	glFlush();
}

// triggered when a keyboard key is pressed
void keyEvent(unsigned char key,int x,int y){	// x,y mouse location when key pressed
  
    switch (key) {
      // Quit
    case 'Q':
    case 'q':
	exit(0);
	break;	      
    default:	
	break;
    
    }
}

void myMouse(int button, int state, GLint xm, GLint ym)
{
	if(button==GLUT_LEFT_BUTTON && state==GLUT_DOWN)
	{
		glColor3f(0.0, 0.0, 1.0);
				
		clipWindow[0].x= xm;
		clipWindow[0].y =screenHeight - ym;
		numCorners =1;
		glutPostRedisplay();
	}
	else if (button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN)
		glClear(GL_COLOR_BUFFER_BIT);
		
		glFlush();
}
 void moveMouse(int xnew, int ynew)
 {
	 clipWindow[1].x= xnew;
	 clipWindow[1].y =screenHeight - ynew;
	 numCorners=2;
	 glutPostRedisplay();

 }

int main(int argc, char** argv) 
{
	//initialize toolkit
	glutInit(&argc, argv);
	//set display mode 
	glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB); 
	//set window size
	glutInitWindowSize (640, 480);
	//set window initial position
	glutInitWindowPosition (1, 1);
	//creates a window 
	glutCreateWindow ("glutMouseFunc2");
			
	glutDisplayFunc(display);
	
	//registers a keyboard handler
	glutKeyboardFunc(keyEvent);
	glutMouseFunc(myMouse);	
	glutMotionFunc(moveMouse);
	//additional initializatons
	init ();
	
	//perpetual ever processing loop
	glutMainLoop(); 
	return 0;	
}      

void drawPoint(GLint x, GLint y)
{
	glColor3f(0.0, 0.0, 1.0);
		
	glBegin(GL_POINTS);
		glVertex2i(x,y);
	glEnd();
	glFlush();
}